package MainApp;


import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.image.BufferedImage;
import java.util.ArrayList;
import java.util.Random;

import javax.swing.JFrame;

import Math.BallGenerator;
import Math.MathCalc;
import Math.Physik;
import Math.Vektor2D;
import Objekts.Ball;




public class Main extends JFrame implements Runnable, MouseListener {
	
	static final int Screen_W = 640; 
	static final int Screen_H = 480; 
	
	// the loop for the animation
	Thread gameLoop; 
	
	// double buffered objects (smooth animation)
	BufferedImage backbuffer; 
	Graphics2D g2d; 	
	
	// Test Objects 	
	Physik physik; 
	ArrayList<Object> objects;  
	//Ball b1; 
	
	@SuppressWarnings("unchecked")
	public Main() {
		/**
		 * Here we create the window and the regarding options
		 */
		super("PhysikBalls"); 
		setSize(Screen_W, Screen_H); 
		setVisible(true);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		/**
		 * Know we create the double buffered objects for a smooth
		 * animation.
		 * Then we can paint and refresh the screen smoothly.
		 */
		backbuffer = new BufferedImage(Screen_W, Screen_H, BufferedImage.TYPE_INT_RGB); 
		g2d = backbuffer.createGraphics(); 
		
		/**
		 * Initialize the test Objects
		 */
		objects = (new BallGenerator(Screen_W, Screen_H)).BallList(10); 
	   // b1 = new Ball( new Vektor2D(250, 100), new Vektor2D(1, 0), 1, 5, 5); 
		physik = new Physik(Screen_W, Screen_H, g2d, objects); 
		
		/**
		 * We start the thread in which we want to run the animation
		 */
		addMouseListener(this); 
		gameLoop = new Thread(this); 
		gameLoop.start(); 
	}
	
	@Override
	public void run() {
		Thread current = Thread.currentThread(); 
		while(current == gameLoop){
			try{
				Thread.sleep(1000 / 30);
			}catch(InterruptedException e){
				e.printStackTrace();	
			}
			updateGame();
		}
	}

	public void updateGame(){
		/**
		 * Start with refreshing the Screen.
		 * After all you have to repaint the whole
		 * Screen.
		 */
		g2d.setColor(Color.BLACK);
		g2d.fillRect(0, 0,Screen_W - 1, Screen_H - 1);	
	

		for(int i = 0; i < objects.size(); i++){			
			
			//physik.gravity((Ball)objects.get(i)); 
			physik.checkBallCollision((Ball)objects.get(i)); 
			physik.bounceWall((Ball)objects.get(i));
			
			((Ball)objects.get(i)).drawBody(g2d, Color.YELLOW);
			((Ball)objects.get(i)).move(); 
		}
/*
		physik.gravity(b1);
		physik.bounceWall(b1);
		b1.drawBody(g2d, Color.RED);
		b1.move();
*/		
		repaint(); 
	}
	
	public void paint(Graphics g){
		g.drawImage(backbuffer, 0, 0, this); 
	}

	public static void main(String[] args) {
		new Main(); 
	}

	@Override
	public void mouseClicked(MouseEvent e) {
		// TODO Auto-generated method stub
        Random rand = new Random(); 
		int radius = 5; //rand.nextInt( 10 ) + 1; 
		int xPos = e.getX();
		int yPos = e.getY(); 			
		int mass = radius; 
		objects.add((Ball)new Ball(new Vektor2D(xPos, yPos), new Vektor2D(0, 1), 0, mass, radius));
	}

	@Override
	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseEntered(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseExited(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}


}

