package Math;

import java.awt.Graphics2D;
import java.util.ArrayList;

import Objekts.Ball;

public class Physik {
	// temporary Graphics
	Graphics2D g2d; 
	// for preventing double precision errors
	MathCalc mathCalc; 
	// for the wall bounce
	int Screen_W = 0, Screen_H = 0; 
	// all objects are subclasses of Object (use instance of)
	ArrayList<Object> objects; 
	// constants  
    Vektor2D g = new Vektor2D(0, 1);   
	
	public Physik(int Screen_W, int Screen_H, Graphics2D g2d, ArrayList<Object> objects ) {
		this.Screen_W = Screen_W;
		this.Screen_H = Screen_H; 
		this.g2d = g2d;		
		// add all objects of the world
		this.objects = objects; 
		// error protection for double precission 
		mathCalc = new MathCalc(); 
	}
	
	public void bounceWall(Object obj){
		if( obj instanceof Ball){
			((Ball) obj).bounceWall(Screen_W, Screen_H);
		}
	}
	/**
	 * Hier muss noch eine For-Loop gespart werden
	 */
	public void checkBallCollision(Ball b1){
		
		for(int i = 0; i < objects.size(); i++){
			if(objects.get(i) instanceof Ball){		
			   Ball currentBall = (Ball)objects.get(i);
			   if(b1.collides(currentBall) && !b1.equals(currentBall)){
				  elasticCollisionBalls(b1, currentBall);
			   }
			}
		}
	}
	
	public void checkWallCollision(){
		for(int i = 0; i < objects.size(); i++){
			if(objects.get(i) instanceof Ball)
				bounceWall((Ball)objects.get(i)); 
		}
	}

	
	public void elasticCollisionBalls(Ball b1, Ball b2){
		
		Vektor2D v_n = b2.position().subWith(b1.position()); 
		Vektor2D v_un = v_n.unitVektor(); 
		Vektor2D v_ut = v_un.orthogonalVektor(); 
		
		double v1n = v_un.dotProduct(b1.velocity());
		double v1t = v_ut.dotProduct(b1.velocity());
		double v2n = v_un.dotProduct(b2.velocity());
		double v2t = v_ut.dotProduct(b2.velocity());
		
		double v1tPrime = v1t; 
		double v2tPrime = v2t; 
		
		double v1nPrime = ( v1n * ( b1.mass() - b2.mass() ) + 2.0 * b2.mass() * v2n ) /
				          (b1.mass()  + b2.mass()); 
		double v2nPrime = ( v2n * ( b2.mass() - b1.mass() ) + 2.0 * b1.mass() * v1n ) /
		                  (b1.mass()  + b2.mass());

		
		Vektor2D v_v1nPrime = v_un.mulWith(v1nPrime); 
		Vektor2D v_v1tPrime = v_ut.mulWith(v1tPrime); 		
		Vektor2D v_v2nPrime = v_un.mulWith(v2nPrime); 
		Vektor2D v_v2tPrime = v_ut.mulWith(v2tPrime); 
		
		b1.velocity().setX( v_v1nPrime.x() + v_v1tPrime.x());
		b1.velocity().setY( v_v1nPrime.y() + v_v1tPrime.y());
		
		b2.velocity().setX( v_v2nPrime.x() + v_v2tPrime.x());
		b2.velocity().setY( v_v2nPrime.y() + v_v2tPrime.y());

		
		// do some correction for keeping the double precision 
		b1.velocity().setX( mathCalc.roundDouble(b1.velocity().x, 14));
		b1.velocity().setY( mathCalc.roundDouble(b1.velocity().y, 14)); 
		
		b2.velocity().setX( mathCalc.roundDouble(b2.velocity().x, 14)); 
		b2.velocity().setY( mathCalc.roundDouble(b2.velocity().y, 14)); 
		
		b1.move();
		b2.move(); 
	}
	
	public void gravity(Ball b1){
		b1.velocity().setX(b1.velocity().x() + g.x());
		b1.velocity().setY(b1.velocity().y() + g.y());
		
		if(b1.position().y() + b1.radius() > Screen_H){
			b1.position().setY(b1.position().y() + 2*b1.radius() - 1); 
		}
	}

}
