package Math;

public class Vektor2D {
	
	// The x and y Coordinates
	double x = 0, y = 0; 
	
	public Vektor2D(double x, double y) {
		this.x = x; 
		this.y = y; 
	}
	public Vektor2D(){}
	
	// get / set Methods
	public double x() { return x; }
	public double y() { return y; }
	
	public void setX(double x) { this.x = x; }
	public void setY(double y) { this.y = y; }
	
	public double magnitude() { return Math.sqrt(Math.pow(x,2) + Math.pow(y, 2)); }
	public double dotProduct( Vektor2D v) { return (x * v.x()) + (y * v.y()); }
	
	// return Methods
	public Vektor2D addWith(Vektor2D v) { return new Vektor2D(x + v.x(), y + v.y()); }
	public Vektor2D subWith(Vektor2D v) { return new Vektor2D(x - v.x(), y - v.y()); }
	public Vektor2D mulWith(double fak) { return new Vektor2D(x * fak  , y * fak  ); } 
	public Vektor2D unitVektor() { return new Vektor2D(x, y).mulWith(1/magnitude()); }
	public Vektor2D orthogonalVektor() { return new Vektor2D(-y, x); }
	
	
	// printer Methods
	public void printVektor(){
		System.out.format("Vektor: %s [ %f, %f]\n", this, x(), y()); 
	}
}
